SystemOrganization addCategory: #GraphAlgorithms!

Object subclass: #GraphAlgorithms
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithms methodsFor: 'as yet unclassified' stamp: 'Deniels 12/19/2011 14:24'!
applyOn: view! !

GraphAlgorithms subclass: #GraphFindFreeNodes
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindFreeNodes methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 14:55'!
applyOn: nodes
	"method to find all free node"
	|freeNodes free|
	freeNodes := OrderedCollection new.
	nodes do: [:node | (node incomingEdges size = 0) ifTrue: [ (node outgoingEdges size = 0) ifTrue: [freeNodes add: node] ] ].
	free := freeNodes collect: #model.
	Transcript show: free.
	^free! !

GraphAlgorithms subclass: #GraphFindMostFanInNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanInNode methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 15:03'!
applyOn: nodes
	"method to find a node with most incomingEdges"
	|maxFanIn theNode theMostFanInNode|
	maxFanIn := 0.
	nodes do: [:node | (node incomingEdges size > maxFanIn) ifTrue: [ 
			maxFanIn := node incomingEdges size.
			theNode := node]].
	theMostFanInNode := OrderedCollection new.
	theMostFanInNode add: theNode.
	theNode := theMostFanInNode collect: #model.		
	^theNode.! !

GraphAlgorithms subclass: #GraphFindMostFanOutNode
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphFindMostFanOutNode methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 15:08'!
applyOn: nodes
	"method to find a node with most incomingEdges"
	|maxFanOut theNode theMostFanOutNode|
	maxFanOut := 0.
	nodes do: [:node | (node outgoingEdges size > maxFanOut) ifTrue: [ 
			maxFanOut := node outgoingEdges size.
			theNode := node]].
	theMostFanOutNode := OrderedCollection new.
	theMostFanOutNode add: theNode.
	theNode := theMostFanOutNode collect: #model.		
	^theNode.! !

TestCase subclass: #GraphAlgorithmsTest
	instanceVariableNames: 'nodes'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GraphAlgorithms'!

!GraphAlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/19/2011 15:12'!
setUp 
	|view|
	view := MOViewRenderer new.
	nodes :=view nodes: (1 to: 6).
	view edgesFromAssociations: {
		"the node 3 is free"
		"the node 1 has more than others outgoingEdges"
		"the node 5 has more than others incomingEdges"
		1 -> 2.
		1 -> 4.
		2 -> 5.
		1 -> 5
	}.! !

!GraphAlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 14:54'!
testGraphFindFreeNodes 
	|res respuesta|
	res := GraphFindFreeNodes new applyOn: nodes.
	respuesta := OrderedCollection new.
	respuesta add: 3.
	respuesta add: 6.
	Transcript show: res; cr.
	Transcript show: respuesta; cr.
	self assert: (res) = respuesta! !

!GraphAlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 15:07'!
testGraphFindMostFanInNode
	|res respuesta|
	res := GraphFindMostFanInNode  new applyOn: nodes.
	respuesta := OrderedCollection new.
	respuesta add: 5.
	self assert: (res) = respuesta! !

!GraphAlgorithmsTest methodsFor: 'as yet unclassified' stamp: 'Deniels 12/20/2011 15:08'!
testGraphFindMostFanOutNode
	|res respuesta|
	res := GraphFindMostFanOutNode new applyOn: nodes.
	"Transcript show: res; cr."
	respuesta := OrderedCollection new.
	respuesta add: 1.
	self assert: (res) = respuesta
	! !
